#in this file I compare the results of the different models using likelihood
l_tau10_vec=rep(0,11)
l_tauMLE_vec=rep(0,11)
l_multinom_vec=rep(0,11)
seasons = c("1011","1112","1213","1314","1415","1516","1617","1718","1819","1920","2021")

#season = ""
for(j in 1:11){
  season = seasons[j]
file1 = paste0("probsTau10_",season,".csv")
file2 = paste0("probsTauMLE_",season,".csv")
file3 = paste0("probsMultinom_",season,".csv")
PL=eval(as.symbol(paste0("pl_",season)))
p_tau10 = read.csv(file = file1)
p_tauMLE = read.csv(file = file2)
p_multinom = read.csv(file = file3)
probsTau = cbind(p_tau10$V1,p_tau10$V2,p_tau10$V3)[171:360,]
probsMLE = cbind(p_tauMLE$V1,p_tauMLE$V2,p_tauMLE$V3)[171:360,]
probsMultinom = cbind(p_multinom$V1,p_multinom$V2,p_multinom$V3)[171:360,]
X = cbind(as.numeric(PL$FTR=="H"),as.numeric(PL$FTR=="D"),as.numeric(PL$FTR=="A"))[191:380,]
l_tau10 = 0
l_tauMLE = 0
l_multinom = 0
for(i in 1:length(X[,1])){
  l_tau10 = l_tau10 - dmultinom(X[i,],prob=probsTau[i,],log=T)
  l_tauMLE = l_tauMLE - dmultinom(X[i,],prob=probsMLE[i,],log=T)
  l_multinom = l_multinom - dmultinom(X[i,],prob=probsMultinom[i,],log=T)
}
l_tau10_vec[j]= l_tau10
l_tauMLE_vec[j]=l_tauMLE
l_multinom_vec[j]=l_multinom 
}
sum(l_tau10_vec)
sum(l_tauMLE_vec)
sum(l_multinom_vec)

#below is  the comparison of the constant models aswell
l_Pois_vec = rep(0,11)
l_GP_vec = rep(0,11)
l_HL_vec = rep(0,11)
l_Multi_vec = rep(0,11)
seasons = c("1011","1112","1213","1314","1415","1516","1617","1718","1819","1920","2021")
for( j in 1:11){
  print(j)
  season=seasons[j]
  PL=eval(as.symbol(paste0("pl_",season)))
  probs_Pois = timePoisBIToProbs(PL,19)
  probs_GP = timeGPtoProbs(PL,19)
  probs_HL = HLCtoProbs(PL,19)
  probs_Multi = multinomToProbs(PL,19)
  X = cbind(as.numeric(PL$FTR=="H"),as.numeric(PL$FTR=="D"),as.numeric(PL$FTR=="A"))[191:380,]
  l_Pois = 0
  l_GP = 0
  l_HL = 0
  l_Multi = 0
  for(i in 1:length(X[,1])){
    l_Pois = l_Pois - dmultinom(X[i,],prob=probs_Pois[i,],log=T)
    l_GP = l_GP - dmultinom(X[i,],prob=probs_GP[i,],log=T)
    l_HL = l_HL - dmultinom(X[i,],prob=probs_HL[i,],log=T)
    l_Multi = l_Multi - dmultinom(X[i,],prob=probs_Multi[i,],log=T)
  }
  l_Pois_vec[j]=l_Pois
  l_GP_vec[j]=l_GP
  l_HL_vec[j]=l_HL
  l_Multi_vec[j]=l_Multi
}
sum(l_Pois_vec)
sum(l_GP_vec)
sum(l_HL_vec)
sum(l_Multi_vec)

