#the data intensive model 


season = 1920# assigning what seasons you would like to study
sesong = as.character(season)
PL = eval(as.symbol(paste0("pl_",sesong))) # assigning what seasons you would like to study
M = 19#the number of rounds after round 19. This was mainly a nesesaty when the current season(20/21) was not finished yet
teams = levels(as.factor(PL$HomeTeam))
Sh = pmax(PL$HS,PL$HST)
Sa = pmax(PL$AS,PL$AST)
Th = pmax(PL$HST,PL$FTHG)
Ta = pmax(PL$AST,PL$FTAG)
x = PL$FTHG
y = PL$FTAG
HA = HomeAway(PL)
home = as.factor(HA[,1]-1)
away = as.factor(HA[,2]-1)
data = list(x=x,y=y,Sh=Sh,Sa=Sa,Th=Th,Ta=Ta,home=home,away=away)
parameters = list(a=rep(0,nlevels(home)),b=rep(0,nlevels(home)),g=rep(0,nlevels(home)),log_lambda=rep(log(25),nlevels(home)),log_h=0)

obj <- MakeADFun(data=data,parameters=parameters,DLL = "HLC2", silent = TRUE)
resDI <- optim(par = obj$par, fn = obj$fn, gr = obj$gr, method = "BFGS")
repDI = sdreport(obj)
a = pnorm(repDI$par.fixed[1:20])
b = pnorm(repDI$par.fixed[21:40])
g = pnorm(repDI$par.fixed[41:60])
lambda = exp(repDI$par.fixed[61:80])
h = exp(repDI$par.fixed[81])

plot(lambda,type = "b",xaxt="n",xlab =NA,ylab = "Expected number of chances created in a match",ylim=c(14,35),
     main = paste0("Lambda in data intensive model season = ",substring(sesong,1,2),"/",substring(sesong,3,4)))
axis(1,at=1:20,teams,las=2,cex.axis=0.7,col="blue")
lines(lambda*h,type = "b",col="blue")
legend("topleft",legend = c("Home","Away"),col = c("blue","black"),lty=1)

plot(b,type = "b",xaxt="n",xlab =NA,ylab = "Probability of chances becoming a shot against the team",ylim=c(0,1),
     main = paste0("Phi(b) in data intensive model season = ",substring(sesong,1,2),"/",substring(sesong,3,4)),col="blue")
axis(1,at=1:20,teams,las=2,cex.axis=0.7,col="blue")

plot(a,type = "b",xaxt="n",xlab =NA,ylab = "Probability of a shot hitting target for the attacking team",ylim=c(0,1),
     main = paste0("Phi(a) in data intensive model season = ",substring(sesong,1,2),"/",substring(sesong,3,4)),col="blue")
axis(1,at=1:20,teams,las=2,cex.axis=0.7,col="blue")


plot(g,type = "b",xaxt="n",xlab =NA,ylab = "Probability of the keeper not saving a shot on target",ylim=c(0,1),
     main = paste0("Phi(g) in data intensive model season = ",substring(sesong,1,2),"/",substring(sesong,3,4)),col="blue")
axis(1,at=1:20,teams,las=2,cex.axis=0.7,col="blue")

############################################################################################################################
probs = HLCtoProbs(PL,M)
odds= cbind(PL$B365H,PL$B365D,PL$B365A)[191:(190+M*10),]
results = PL$FTR[191:(190+M*10)]

#the results using fixed bets
coin = fixedBet(probs,odds,1,results)
plot(coin,type = "l",col="red",ylim=c(-5,15),lwd=2,main = paste0("Fixed bet. Season = ",substring(sesong,1,2),"/",substring(sesong,3,4)),xlab = "#rounds after round 19",ylab = "Money earned" )
for(i in 1:20){
  coinA = fixedBet(probs,odds,1,randomResults(probs))
  lines(coinA,col=greys[i])
}
abline(h=0,col="blue")
legend("topleft",legend = c("The betting results","line at zero","different realizations"),
       lwd=c(2,1,1),lty=1,col=c("red","blue",greys[1]))

coin[M+1]/M*100#the return on investment in percent

#the results using fixed return 

coin = FixedReturn(probs,odds,1,results)
plot(coin,type = "l",ylim=c(-5,10),col="red",lwd=3,main = paste0("Fixed return. Season = ",substring(sesong,1,2),"/",substring(sesong,3,4)),
     xlab = "Rounds of betting",ylab = "Money earned")
for(i in 1:20){
  coinA = fixedBet(probs,odds,1,randomResults(probs))
  lines(coinA,col=greys[i])
}
abline(h=0,col="blue")
legend("topleft",legend = c("The betting results","line at zero","different realizations"),
       lwd=c(2,1,1),lty=1,col=c("red","blue",greys[1]))
coin[M+1]/M*100

#the results  using rue and salvesen betting strategy 
coin = RueVariance(probs,odds,1,results)
plot(coin,type = "l",col="red",lwd=3,ylim = c(-4,10),ylab = "Money earned",xlab="Rounds of betting",main=paste0("Rue & Salvesen, model: Data intensive, season = ",substring(sesong,1,2),"/",substring(sesong,3,4)))
for(i in 1:20){
  coinA = RueVariance(probs,odds,1,randomResults(probs))
  lines(0:M,coinA,col=greys[i])
}
abline(h=0,lty=3,col="blue")
legend("topleft",legend = c("Money earned","The end results","Different realizations"),lty = c(1,3,1),lwd=c(3,1,1),
       col = c("red","blue","grey"))
coin[M+1]/M*100

################################################################################################################################
#the odds and estimated probability is plotted together in here

plotOddsLog(odds,probs,results,season = paste0(substring(sesong,1,2),"/",substring(sesong,3,4)),model = "Data intensive")



#deviance test to see if the model is significant 

#the data to be used by both models
teams = levels(as.factor(PL$HomeTeam))
Sh = pmax(PL$HS,PL$HST)
Sa = pmax(PL$AS,PL$AST)
Th = pmax(PL$HST,PL$FTHG)
Ta = pmax(PL$AST,PL$FTAG)
x = PL$FTHG
y = PL$FTAG
HA = HomeAway(PL)
home = as.factor(HA[,1]-1)
away = as.factor(HA[,2]-1)
#the full model
data = list(x=x,y=y,Sh=Sh,Sa=Sa,Th=Th,Ta=Ta,home=home,away=away)
parameters = list(a=rep(0,nlevels(home)),b=rep(0,nlevels(home)),g=rep(0,nlevels(home)),log_lambda=rep(log(25),nlevels(home)),log_h=0)


obj <- MakeADFun(data=data,parameters=parameters,DLL = "HLC2", silent = TRUE)
resDI <- optim(par = obj$par, fn = obj$fn, gr = obj$gr, method = "BFGS")
repDI = sdreport(obj)

#the null model

data = list(x=x,y=y,Sh=Sh,Sa=Sa,Th=Th,Ta=Ta,home=home,away=away)
parameters = list(a=0,b=rep(0,nlevels(home)),g=0,log_lambda=rep(log(25),nlevels(home)),log_h=0)

obj <- MakeADFun(data=data,parameters=parameters,DLL = "HLC0", silent = TRUE)
resDI0 <- optim(par = obj$par, fn = obj$fn, gr = obj$gr, method = "BFGS")
repDI0 = sdreport(obj)

#the test

d = -2*(resDI$value-resDI0$value)
1-pchisq(d,38)


#deviance test for just the alpha parameter
data = list(x=x,y=y,Sh=Sh,Sa=Sa,Th=Th,Ta=Ta,home=home,away=away)
parameters = list(a=0,b=rep(0,nlevels(home)),g=rep(0,nlevels(home)),log_lambda=rep(log(25),nlevels(home)),log_h=0)


obj <- MakeADFun(data=data,parameters=parameters,DLL = "HLCA", silent = TRUE)
resDIA <- optim(par = obj$par, fn = obj$fn, gr = obj$gr, method = "BFGS")
repDIA = sdreport(obj)

#the deviance test for alpha

d = -2*(resDI$value-resDIA$value)
1-pchisq(d,19)

