#this file uses the time dependent models 

s=12#the season one wants to look at 

PL = EPL

start = 3#the round in the season to start, needs to be >2
slutt = 38#the round in the season to end, start<=slutt<=38
n1 = 0 # the game before the first game to start your data set on, usually set to 0
M1 = (s-1)*380+(start-1)*10#the last to look at before the estimates.

#the model with tau=const
tau = 10
p_tau = fullToProbsTauCH(PL,start,slutt,n1,M1,tau,2)
probs_tau = p_tau[171:360,]#probabilities for second half of season
PL[M1+1,]
write.csv(p_tau,file="probsTau10_2021.csv")#saving the probabilities to file, need to change name for each season



odds = cbind(PL$B365H[(M1+1):(M1+(slutt-start+1)*10)],PL$B365D[(M1+1):(M1+(slutt-start+1)*10)],PL$B365A[(M1+1):(M1+(slutt-start+1)*10)])
results = PL$FTR[(M1+1):(M1+(slutt-start+1)*10)]
fixedBet(p_tau,odds,1,results)[((slutt-start+2))]/(slutt-start+1)*100#the return in percent for fixed bet
FixedReturn(p_tau,odds,1,results)[((slutt-start+2))]/(slutt-start+1)*100#the return in percent for fixed return
RueVariance(p_tau,odds,1,results)[((slutt-start+2))]/(slutt-start+1)*100#the return in percent for rue and salvesen betting strategy
(testKelly(p_tau,odds,1000,results,0.2)[length(results)+1]-1000)/1000*100#the return in percent for kelly criterion


odds1 = odds[171:((slutt-2)*10),]#odds for second half of season
results1 = results[171:((slutt-2)*10)]#results for second half of seasons
fixedBet(probs_tau,odds1,1,results1)[slutt-19+1]/(slutt-19)*100
FixedReturn(probs_tau,odds1,1,results1)[(slutt-19+1)]/(slutt-19)*100
RueVariance(probs_tau,odds1,1,results1)[((slutt-19+1))]/(slutt-19)*100
(testKelly(probs_tau,odds1,1000,results1,0.2)[length(results1)+1]-1000)/1000*100


#the model with tau from MLE

p_mle = fullToProbsTauMLECH(PL,start,slutt,n1,M1,2)
probs_mle = p_mle[171:360,]#probabilities for second half of season
PL[M1+1,]
write.csv(p_mle,file="probsTauMLE_2021.csv")#saving the probabilities to file, need to change name for each season

odds = cbind(PL$B365H[(M1+1):(M1+(slutt-start+1)*10)],PL$B365D[(M1+1):(M1+(slutt-start+1)*10)],PL$B365A[(M1+1):(M1+(slutt-start+1)*10)])
results = PL$FTR[(M1+1):(M1+(slutt-start+1)*10)]
fixedBet(p_mle,odds,1,results)[((slutt-start+2))]/(slutt-start+1)*100
FixedReturn(p_mle,odds,1,results)[((slutt-start+2))]/(slutt-start+1)*100
RueVariance(p_mle,odds,1,results)[((slutt-start+2))]/(slutt-start+1)*100
(testKelly(p_mle,odds,1000,results,0.2)[length(results)+1]-1000)/1000*100


odds1 = odds[171:((slutt-2)*10),]
results1 = results[171:((slutt-2)*10)]
fixedBet(probs_mle,odds1,1,results1)[slutt-19+1]/(slutt-19)*100
FixedReturn(probs_mle,odds1,1,results1)[(slutt-19+1)]/(slutt-19)*100
RueVariance(probs_mle,odds1,1,results1)[((slutt-19+1))]/(slutt-19)*100
(testKelly(probs_mle,odds1,1000,results1,0.2)[length(results1)+1]-1000)/1000*100

#the multinomial model '



p_multi = fullMultinomToProbs(PL,start,slutt,n1,M1)

probs_multi = p_tau[171:360,]#probabilities for second half of season
PL[M1+1,]
write.csv(p_multi,file="probsMultinom_2021.csv")#saving the probabilities to file, need to change name for each season



odds = cbind(PL$B365H[(M1+1):(M1+(slutt-start+1)*10)],PL$B365D[(M1+1):(M1+(slutt-start+1)*10)],PL$B365A[(M1+1):(M1+(slutt-start+1)*10)])
results = PL$FTR[(M1+1):(M1+(slutt-start+1)*10)]
fixedBet(p_multi,odds,1,results)[((slutt-start+2))]/(slutt-start+1)*100
FixedReturn(p_multi,odds,1,results)[((slutt-start+2))]/(slutt-start+1)*100
RueVariance(p_multi,odds,1,results)[((slutt-start+2))]/(slutt-start+1)*100
(testKelly(p_multi,odds,1000,results,0.2)[length(results)+1]-1000)/1000*100


odds1 = odds[171:((slutt-2)*10),]
results1 = results[171:((slutt-2)*10)]
fixedBet(probs_multi,odds1,1,results1)[slutt-19+1]/(slutt-19)*100
FixedReturn(probs_multi,odds1,1,results1)[(slutt-19+1)]/(slutt-19)*100
RueVariance(probs_multi,odds1,1,results1)[((slutt-19+1))]/(slutt-19)*100
(testKelly(probs_multi,odds1,1000,results1,0.2)[length(results1)+1]-1000)/1000*100



probs = timeGPtoProbs(PL,M)
plotOddsLog(odds,probs,results,season = paste0(substring(sesong,1,2),"/",substring(sesong,3,4)),model = "Generalized Poisson GLMM")

#the plots for the odds-probability realtionship for the time-dependent models
p = read.csv(file="probsTau10_2021.csv")
probs = cbind(p$V1,p$V2,p$V3)[171:360,]
plotOddsLog(odds,probs,results,season = paste0(substring(sesong,1,2),"/",substring(sesong,3,4)),model = "Const Tau is 100")

p = read.csv(file="probsTauMLE_2021.csv")
probs = cbind(p$V1,p$V2,p$V3)[171:360,]
plotOddsLog(odds,probs,results,season = paste0(substring(sesong,1,2),"/",substring(sesong,3,4)),model = "Tau from MLE")

p = read.csv(file="probsMultinom_2021.csv")
probs = cbind(p$V1,p$V2,p$V3)[171:360,]
plotOddsLog(odds,probs,results,season = paste0(substring(sesong,1,2),"/",substring(sesong,3,4)),model = "Multinomial")





