#this file generates the results used in the multinomial part of the project

season = 1920# assigning what seasons you would like to study
sesong = as.character(season)
PL = eval(as.symbol(paste0("pl_",sesong))) # assigning what seasons you would like to study
M = 19#the number of rounds after round 19. This was mainly a nesesaty when the current season(20/21) was not finished yet

X = cbind(as.numeric(PL$FTR=="H"),as.numeric(PL$FTR=="D"),as.numeric(PL$FTR=="A"))
HA = HomeAway(PL)
home = as.factor(HA[,1]-1)
away = as.factor(HA[,2]-1)
data = list(X=X,home=home,away=away)
parameters = list(theta=0.1,h=0,lam=rep(0,nlevels(home)),log_sigma=-1)
random = c("lam")

obj <- MakeADFun(data=data,parameters=parameters,random = random,DLL = "multinomRI", silent = TRUE)
resMulti <- optim(par = obj$par, fn = obj$fn, gr = obj$gr, method = "BFGS")

repMulti = sdreport(obj)
#####################################################################################################
#the results using the betting market
probs = multinomToProbs(PL,M)
odds= cbind(PL$B365H,PL$B365D,PL$B365A)[191:(190+M*10),]
results = PL$FTR[191:(190+M*10)]

#the results using fixed bets
coin = fixedBet(probs,odds,1,results)
plot(coin,type = "l",col="red",ylim=c(-5,15),lwd=2,main = paste0("Fixed bet. Season = ",substring(sesong,1,2),"/",substring(sesong,3,4)),xlab = "#rounds after round 19",ylab = "Money earned" )
for(i in 1:20){
  coinA = fixedBet(probs,odds,1,randomResults(probs))
  lines(coinA,col=greys[i])
}
abline(h=0,col="blue")
legend("topleft",legend = c("The betting results","line at zero","different realizations"),
       lwd=c(2,1,1),lty=1,col=c("red","blue",greys[1]))

coin[M+1]/M*100#the return on investment in percent

#the results using fixed return 

coin = FixedReturn(probs,odds,1,results)
plot(coin,type = "l",ylim=c(-5,10),col="red",lwd=3,main = paste0("Fixed return. Season = ",substring(sesong,1,2),"/",substring(sesong,3,4)),
     xlab = "Rounds of betting",ylab = "Money earned")
for(i in 1:20){
  coinA = fixedBet(probs,odds,1,randomResults(probs))
  lines(coinA,col=greys[i])
}
abline(h=0,col="blue")
legend("topleft",legend = c("The betting results","line at zero","different realizations"),
       lwd=c(2,1,1),lty=1,col=c("red","blue",greys[1]))
coin[M+1]/M*100

#the results  using rue and salvesen betting strategy 
coin = RueVariance(probs,odds,1,results)
plot(coin,type = "l",col="red",lwd=3,ylim = c(-4,10),ylab = "Money earned",xlab="Rounds of betting",main=paste0("Rue & Salvesen,model: Multinomial GLMM, season = ",substring(sesong,1,2),"/",substring(sesong,3,4)))
for(i in 1:20){
  coinA = RueVariance(probs,odds,1,randomResults(probs))
  lines(0:M,coinA,col=greys[i])
}
abline(h=0,lty=3,col="blue")
legend("topleft",legend = c("Money earned","The end results","Different realizations"),lty = c(1,3,1),lwd=c(3,1,1),
       col = c("red","blue","grey"))
coin[M+1]/M*100

################################################################################################################################
#the odds and estimated probability is plotted together in here

plotOddsLog(odds,probs,results,season = paste0(substring(sesong,1,2),"/",substring(sesong,3,4)),model = "Multinomial GLMM")


