#this file is used to find the results in the section about the data in the project
# it  assumed that the Data.R file has been run
library(extraDistr)
library(ggplot2)
pl =EPL
hist(pl$FTHG,freq=T,col="blue",main = "Histogram of home goals. Season = 09/10-20/21",
     ylab= "Number of times",xlab = "Number of goals scored",breaks = -1:9+1/2)

points(0:8,dpois(0:8,mean(pl$FTHG))*length(pl$FTHG),col="red",cex=1,pch=22,bg="red")
legend("topright",legend = c("Expected number assuming poisson",paste("E(X)=",round(mean(pl$FTHG),2)),paste("Var(X)=",round(var(pl$FTHG),2))),
       col="red",pch = c(22,NA,NA),pt.bg="red",pt.cex=1)

hist(pl$FTAG,freq=T,col="blue",main = "Histogram of home goals. Season = 09/10-20/21",
     ylab= "Number of times",xlab = "Number of goals scored",breaks = -1:9+1/2,ylim=c(0,1600))

points(0:8,dpois(0:8,mean(pl$FTAG))*length(pl$FTAG),col="red",cex=1,pch=22,bg="red")
legend("topright",legend = c("Expected number assuming poisson",paste("E(X)=",round(mean(pl$FTHG),2)),paste("Var(X)=",round(var(pl$FTHG),2))),
       col="red",pch = c(22,NA,NA),pt.bg="red",pt.cex=1)


cov(pl$FTHG,pl$FTAG)/sqrt(var(pl$FTHG)*var(pl$FTAG))#the correlation of number of goals scored by each team.

m = 380

HomeGoals = c(mean(EPL$FTHG[1:m]),mean(EPL$FTHG[(m+1):(2*m)]),mean(EPL$FTHG[(2*m+1):(3*m)]),mean(EPL$FTHG[(3*m+1):(4*m)]),mean(EPL$FTHG[(4*m+1):(5*m)]),
              mean(EPL$FTHG[(5*m+1):(6*m)]),mean(EPL$FTHG[(6*m+1):(7*m)]),mean(EPL$FTHG[(7*m+1):(8*m)]),mean(EPL$FTHG[(8*m+1):(9*m)]),mean(EPL$FTHG[(9*m+1):(10*m)]),
              mean(EPL$FTHG[(10*m+1):(11*m)]),mean(EPL$FTHG[(11*m+1):(length(EPL$FTHG))]))

AwayGoals = c(mean(EPL$FTAG[1:m]),mean(EPL$FTAG[(m+1):(2*m)]),mean(EPL$FTAG[(2*m+1):(3*m)]),mean(EPL$FTAG[(3*m+1):(4*m)]),mean(EPL$FTAG[(4*m+1):(5*m)]),
              mean(EPL$FTAG[(5*m+1):(6*m)]),mean(EPL$FTAG[(6*m+1):(7*m)]),mean(EPL$FTAG[(7*m+1):(8*m)]),mean(EPL$FTAG[(8*m+1):(9*m)]),mean(EPL$FTAG[(9*m+1):(10*m)]),
              mean(EPL$FTAG[(10*m+1):(11*m)]),mean(EPL$FTAG[(11*m+1):(length(EPL$FTAG))]))

plot(HomeGoals,ylim = c(1,2),xaxt="n",pch=3,col="blue",xlab = "Seasons",ylab = "Mean number of goals by season",main = "Mean number of goals in each match by seasons")
axis(1,las=2, at=c(1:12),labels=c("09/10","10/11","11/12","12/13","13/14","14/15","15/16","16/17","17/18","18/19","19/20","20/21"))
points(AwayGoals,col="red",pch=4)
points((HomeGoals+AwayGoals)/2,col="black",pch=8)
legend("topright",legend = c("Mean number of home goals","Mean number of away goals","Mean number of gaols"),col=c("blue","red","black"),pch = c(3,4,8))



